> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/xamarin/changelogs/version-6/v6-8-0.md).

# Version 6.8.0 Changelog (April 4, 2018)

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

Version: 6.8.0

Release Date: April 4, 2018

## Notes

In this version, both binding projects for Xamarin.Android and Xamarin.iOS have significant changes. Please read the new tutorial on how to build the binding project for [Xamarin.Android](/xamarin/learn-more/java-android.md) and [Xamarin.iOS](/xamarin/learn-more/objc-ios.md).

## Xamarin.Android

### New features

* Adds `pdftron.PDF.Controls.FindTextOverlay` and `pdftron.PDF.Controls.SearchToolbar` for [easy text search](/xamarin/basic-operations/basics/find-text-a.md)
* Adds `pdftron.PDF.Tools.CustomRelativeLayout` for [easy UI views on top of PDFViewCtrl](/xamarin/guides/advanced/custom-relative-layout.md)
* For more new features, see [Changelog for Android](/android/changelogs/version-6/v6-8-0.md)

### Breaking changes

* `PDFNet.Initialize` no longer accepts null or empty license keys. A valid demo or commercial license key is required at all times. Please request a trial license if you do not have one.
* All DLLs are distributed via NuGet package now, see [Upgrading](/xamarin/learn-more/upgrading.md).
* PDFNetAndroid package no longer comes in split form for each abi, see [Building split APK](/xamarin/get-started/faq/faq-split-apk.md).

#### Enum

* `PDFViewCtrl.DownloadTypes` => `PDFViewCtrl.DownloadState`
* `PDFViewCtrl.PageChangeType` => `PDFViewCtrl.PageChangeState`
* `ToolManager.Mode` => `ToolManager.ToolMode.Value`

#### Enum value

* All enum values in `PDFViewCtrl` has been updated to match native platform convention

#### Event

* Frequently used events have been updated to have meaningful name for the event args instead of `P0`, `P1` and so on
* The second parameter for `PDFViewCtrl.RenderingStarted` and `PDFViewCtrl.RenderingFinished` events is now `EventArgs`
* `PDFViewCtrl.OnSetDoc` => `PDFViewCtrl.DocumentLoad` and the second parameter is now `EventArgs`
* `PDFViewCtrl.TextSearchEnded` => `PDFViewCtrl.TextSearchEnd` and `PDFViewCtrl.TextSearchEndedEventArgs` => `PDFViewCtrl.TextSearchEndEventArgs`
* `AnnotationToolbar.Shown` => `AnnotationToolbar.AnnotationToolbarShown`
* `AnnotationToolbar.Closed` => `AnnotationToolbar.AnnotationToolbarClosed`

#### Changed

* `ToolManager.convToAnnot` => `TypeConvertHelper.ConvAnnotToManaged`
* `ThumbnailSlider.SetPDFViewCtrl` => `ThumbnailSlider.SetPdfViewCtrl`
* `AnnotationToolbar.Setup` now only takes in ToolManager

#### Removed

* `PDFViewCtrl.GetHandleInternal()` is removed. Instead, `PDFViewCtrl` extends the native `PDFViewCtrl` and can be passed into native functions directly
* `ToolManager.SetBuiltInPanModeToolbarEnable` is removed. Instead, use the new `SearchToolbar` and `FindTextOverlay`

## Xamarin.iOS

### New features

* `pdftron.PDF.PDFViewCtrl` now extends the native `PTPDFViewCtrl` class and fully support iOS 11 and iPhone X
* Adds a new annotation style picker
* Adds `pdftron.PDF.Controls.ThumbnailsViewController`: [a thumbnails grid view that allows rearrange and page deletion](/xamarin/guides/viewer-components/thumbnails-view-i.md)
* Adds `pdftron.PDF.Controls.ThumbnailSliderViewController`: [a bottom navigation bar with preview thumbnails](/xamarin/guides/viewer-components/thumbnail-slider-i.md)
* Adds `pdftron.PDF.Controls.FindTextToolbar`: [a toolbar for text search](/xamarin/basic-operations/basics/find-text-a.md)
* Adds `pdftron.PDF.PTPrint` class for easy printing, see sample project for details
* Adds new night mode to `PDFViewCtrl`, use flag `e_postprocess_night_mode` in `PDFViewCtrl.SetColorPostProcessMode`
* RTL support for free text annotations
* Sample project updated to use Auto Layout
* For more new features, see [Changelog for iOS](/ios/changelogs/version-6/v6-8-0.md)

### Breaking changes

* `PDFNet.Initialize` no longer accepts null or empty license keys. A valid demo or commercial license key is required at all times. Please request a trial license if you do not have one.
* All DLLs are distributed via NuGet package now, see [Upgrading](/xamarin/learn-more/upgrading.md).

#### Enum

* All enums in `pdftron.PDF.PDFViewCtrl` class has been moved under namespace `pdftron.PDF`, for example, `pdftron.PDF.PDFViewCtrl.PagePresentationModes` will now be `pdftron.PDF.PagePresentationModes`, values are unchanged

#### Type mapping

* `PDFViewCtrl.Doc` property now expects type `PTPDFDoc`, you can update the code as follows:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
pdftron.PDF.PDFDoc docToOpen;
...
mPdfViewCtrl.Doc = TypeConvertHelper.ConvPDFDocToNative(docToOpen);
docToOpen = TypeConvertHelper.ConvPDFDocToManaged(mPdfViewCtrl.Doc);
```

{% endcode %}
{% endtab %}
{% endtabs %}

* `ToolManager` annotation change events now returns type `PTAnnot`, you can update the code as follows:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
pdftron.PDF.Annot annot = TypeConvertHelper.ConvAnnotToManaged(e.Annotation);
```

{% endcode %}
{% endtab %}
{% endtabs %}

#### Event

* `ToolManager.AnnotationModificationEventArgs` => `pdftron.PDF.Tools.AnnotationModificationEventArgs`
* `PDViewCtrl.PageNumberChanged` => `PDFViewCtrl.PageNumberChangedFrom` with args `PageNumberChangedFromEventArgs`
* `PDViewCtrl.TextSearchEnded` => `PDFViewCtrl.TextSearchResult` with args `TextSearchResultEventArgs`
* `PDFViewCtrl.DocumentDownloaded` => `PDFViewCtrl.DownloadEventType` with args `DownloadEventTypeEventArgs`
* `PDFViewCtrl.SetColorPostProcessMode` takes in `pdftron.PDF.ColorPostProcessMode` instead of `PDFRasterizer.ColorPostProcessMode`
* `ToolManager.ToolChanged` => `ToolManager.ToolManagerToolChanged`
* `AnnotationToolbar.SetToolManager` => `ToolManager` property
* `AnnotationToolbar.ToolShouldGoBackToPan` =>

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
mAnnotationToolbar.ToolShouldGoBackToPan = (annotationToolbar) =>
{
    return false;
};
```

{% endcode %}
{% endtab %}
{% endtabs %}

* `PDFViewCtrl.HighlightSelection` now takes in `PTSelection` which is obtained through `TextSearchResultEventArgs.Selection`, and `PDFViewCtrl.Selection` is no longer needed
* `PDFViewCtrl.OpenURL` => `PDFViewCtrl.OpenUrlAsync`
* `pdftronprivate.AnnotationViewControllerAnnotaionSelectedEventArgs` => `AnnotationViewControllerAnnotaionSelectedEventArgs`
* `pdftronprivate.OutlineViewControllerBookmarkSelectedEventArgs` => `OutlineViewControllerOutlineSelectedEventArgs`
* `pdftronprivate.BookmarkViewControllerBookmarkSelectedEventArgs` => `BookmarkViewControllerBookmarkSelectedEventArgs`

#### EventArgs

* sender is added to all events, for example, `OnSetDoc` used to have `PDFDoc` as the sender, but is now changed to `PDFViewCtrl` as the sender, `OnSetDocEventArgs.Doc` is the `PDFDoc`:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
mPdfViewCtrl.OnSetDoc += (sender, e) =>
{
    PDFDoc doc = TypeConvertHelper.ConvPdfDocToManaged(e.Doc);
    // do something with the doc
};
```

{% endcode %}
{% endtab %}
{% endtabs %}

#### Changed

* `AnnotationToolbar` constructor now takes in `ToolManager`, use Auto Layout for size and position

#### Removed

* `ToolManager.BackToPan()` and `ToolManager.BackToPanToolAfterUse` are removed, use the following instead:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
mToolManager.ChangeTool(new Class(typeof(pdftron.PDF.Tools.PanTool)));
```

{% endcode %}
{% endtab %}
{% endtabs %}

* `BookmarkViewController.DocPath` is no longer needed


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/xamarin/changelogs/version-6/v6-8-0.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
